###################################################
## Power ROC functions ############################
### 16/10/02 ######################################


Power <- function(x, input, ind) {

 method <- attr(input,"method")	
 K <- attr(input,"study")
 type <- attr(input,"type")
 region <- 	attr(input,"region")

if (!(method %in% c("Bayes","Fisher"))) {
	stop("method has to be Bayes or Fisher")
}

if (!(K %in% c(2,5)) ) {
	stop("K has to be 2 or 5")
}

if (!(type %in% c("homo","hetero")) ) {
	stop("type has to be homo or hetero")
}

if (!(region %in% c("low","high")) ) {
	stop("region has to be low or high")
}
	
if (method == "Bayes" & K==2 & type == "homo") {
   out <- tp.number.hsb.meta.bayes.K2.homo(x=x, data = input , ind = ind)
} 	
if (method == "Fisher" & K==2 & type == "homo") {
   out <- tp.number.hsb.fisher.K2.homo(x=x, p = input , ind = ind)	
} 		
	
if (method == "Bayes" & K==5 & type == "homo") {
   out <- tp.number.hsb.meta.bayes.K5.homo(x=x, data = input , ind = ind)	
} 	
if (method == "Fisher" & K==5 & type == "homo") {
   out <- tp.number.hsb.fisher.K5.homo(x=x, p = input , ind = ind)	
} 		

if (method == "Bayes" & K==2 & type == "hetero" & region == "low") {
   out <- tp.number.hsb.meta.bayes.K2.hetero.low(x=x, data = input , ind = ind)	
} 	
if (method == "Fisher" & K==2 & type == "hetero" & region == "low") {
   out <- tp.number.hsb.fisher.K2.hetero.low(x=x, p = input , ind = ind)	
} 	

if (method == "Bayes" & K==2 & type == "hetero" & region == "high") {
   out <- tp.number.hsb.meta.bayes.K2.hetero.high(x=x, data = input , ind = ind)	
} 	
if (method == "Fisher" & K==2 & type == "hetero" & region == "high") {
   out <- tp.number.hsb.fisher.K2.hetero.high(x=x, p = input , ind = ind)	
} 	

if (method == "Bayes" & K==5 & type == "hetero" & region == "low") {
   out <- tp.number.hsb.meta.bayes.K5.hetero.low(x=x, data = input , ind = ind)	
} 	
if (method == "Fisher" & K==5 & type == "hetero" & region == "low") {
   out <- tp.number.hsb.fisher.K5.hetero.low(x=x, p = input , ind = ind)	
} 

if (method == "Bayes" & K==5 & type == "hetero" & region == "high") {
   out <- tp.number.hsb.meta.bayes.K5.hetero.high(x=x, data = input , ind = ind)	
} 	
if (method == "Fisher" & K==5 & type == "hetero" & region == "high") {
   out <- tp.number.hsb.fisher.K5.hetero.high(x=x, p = input , ind = ind)	
} 	
 
 return(out) 
	
}



Sens <- function(x, input, ind, not.ind) {

 method <- attr(input,"method")	
 K <- attr(input,"study")
 type <- attr(input,"type")
 region <- 	attr(input,"region")

if (!(method %in% c("Bayes","Fisher"))) {
	stop("method has to be Bayes or Fisher")
}

if (!(K %in% c(2,5)) ) {
	stop("K has to be 2 or 5")
}

if (!(type %in% c("homo","hetero")) ) {
	stop("type has to be homo or hetero")
}

if (!(region %in% c("low","high")) ) {
	stop("region has to be low or high")
}
	
if (method == "Bayes" & K==2 & type == "homo") {
  out <- sens.spec.meta.bayes.K2.homo(x=x, data= input ,ind= ind,not.ind = not.ind)[1]	
} 	
if (method == "Fisher" & K==2 & type == "homo") {
  out <- sens.fisher.K2.homo(x= x ,p= input,ind= ind)	
} 		
	
if (method == "Bayes" & K==5 & type == "homo") {
  out <- sens.spec.meta.bayes.K5.homo(x=x, data= input ,ind= ind,not.ind = not.ind)[1]	
} 	
if (method == "Fisher" & K==5 & type == "homo") {
  out <- sens.fisher.K5.homo(x= x ,p= input,ind= ind)	
} 	

if (method == "Bayes" & K==2 & type == "hetero" & region == "low") {
  out <- sens.spec.meta.bayes.K2.hetero.low(x=x, data= input ,ind= ind,not.ind = not.ind)[1]	
} 	
if (method == "Fisher" & K==2 & type == "hetero" & region == "low") {
  out <- sens.fisher.K2.hetero.low(x= x ,p= input,ind= ind)	
} 	

if (method == "Bayes" & K==2 & type == "hetero" & region == "high") {
  out <- sens.spec.meta.bayes.K2.hetero.high(x=x, data= input ,ind= ind,not.ind = not.ind)[1]	
} 	
if (method == "Fisher" & K==2 & type == "hetero" & region == "high") {
  out <- sens.fisher.K2.hetero.high(x= x ,p= input,ind= ind)	
} 	

if (method == "Bayes" & K==5 & type == "hetero" & region == "low") {
  out <- sens.spec.meta.bayes.K5.hetero.low(x=x, data= input ,ind= ind,not.ind = not.ind)[1]	
} 	
if (method == "Fisher" & K==5 & type == "hetero" & region == "low") {
  out <- sens.fisher.K5.hetero.low(x= x ,p= input,ind= ind)	
} 

if (method == "Bayes" & K==5 & type == "hetero" & region == "high") {
  out <- sens.spec.meta.bayes.K5.hetero.high(x=x, data= input ,ind= ind,not.ind = not.ind)[1]	
} 	
if (method == "Fisher" & K==5 & type == "hetero" & region == "high") {
  out <- sens.fisher.K5.hetero.high(x= x ,p= input,ind= ind)	
} 	
 return(out)
}


Spec <- function(x, input, ind, not.ind) {

 method <- attr(input,"method")	
 K <- attr(input,"study")
 type <- attr(input,"type")
 region <- 	attr(input,"region")

if (!(method %in% c("Bayes","Fisher"))) {
	stop("method has to be Bayes or Fisher")
}

if (!(K %in% c(2,5)) ) {
	stop("K has to be 2 or 5")
}

if (!(type %in% c("homo","hetero")) ) {
	stop("type has to be homo or hetero")
}

if (!(region %in% c("low","high")) ) {
	stop("region has to be low or high")
}
	
if (method == "Bayes" & K==2 & type == "homo") {
  out <- sens.spec.meta.bayes.K2.homo(x=x, data= input ,ind= ind,not.ind = not.ind)[2]	
} 	
if (method == "Fisher" & K==2 & type == "homo") {
  out <- spec.fisher.K2.homo(x= x ,p= input, not.ind= not.ind)	
} 		
	
if (method == "Bayes" & K==5 & type == "homo") {
  out <- sens.spec.meta.bayes.K5.homo(x=x, data= input ,ind= ind,not.ind = not.ind)[2]	
} 	
if (method == "Fisher" & K==5 & type == "homo") {
  out <- spec.fisher.K5.homo(x= x ,p= input, not.ind = not.ind)	
} 	

if (method == "Bayes" & K==2 & type == "hetero" & region == "low") {
  out <- sens.spec.meta.bayes.K2.hetero.low(x= x, data= input ,ind= ind,not.ind = not.ind)[2]	
} 	
if (method == "Fisher" & K==2 & type == "hetero" & region == "low") {
  out <- spec.fisher.K2.hetero.low(x= x ,p= input, not.ind = not.ind)	
} 	

if (method == "Bayes" & K==2 & type == "hetero" & region == "high") {
  out <- sens.spec.meta.bayes.K2.hetero.high(x=x, data= input ,ind= ind,not.ind = not.ind)[2]	
} 	
if (method == "Fisher" & K==2 & type == "hetero" & region == "high") {
  out <- spec.fisher.K2.hetero.high(x= x ,p= input, not.ind = not.ind)	
} 	

if (method == "Bayes" & K==5 & type == "hetero" & region == "low") {
  out <- sens.spec.meta.bayes.K5.hetero.low(x=x, data= input ,ind= ind,not.ind = not.ind)[2]	
} 	
if (method == "Fisher" & K==5 & type == "hetero" & region == "low") {
  out <- spec.fisher.K5.hetero.low(x= x ,p= input, not.ind = not.ind)	
} 

if (method == "Bayes" & K==5 & type == "hetero" & region == "high") {
  out <- sens.spec.meta.bayes.K5.hetero.high(x=x, data= input ,ind= ind,not.ind = not.ind)[2]	
} 	
if (method == "Fisher" & K==5 & type == "hetero" & region == "high") {
  out <- spec.fisher.K5.hetero.high(x= x ,p= input, not.ind = not.ind)	
} 	
 return(out)	
}



tp.number.hsb.meta.bayes.K2.homo <-function(x,data,ind){
  name1<-names(sort(data[,1],decreasing=T))
  t.name1<-name1[which(name1[1:x] %in% paste('gene',ind,sep='')==T)]
  name2<-names(sort(data[,2],decreasing=T))
  t.name2<-name2[which(name2[1:x] %in% paste('gene',ind,sep='')==T)]
  true<-union(t.name1,t.name2)
  if(length(true)>=x) {return(x)}
  else return(length(true)) 
}

tp.number.hsb.fisher.K2.homo <-function(x, p, ind){
  name<-names(sort(p,decreasing=F))
  t.name<-name[which(name[1:x] %in% paste('gene',ind,sep='')==T)]
  return(length(t.name))
}


tp.number.hsb.meta.bayes.K5.homo <-function(x,data,ind){
  name1<-names(sort(data[,1],decreasing=T))
  t.name1<-name1[which(name1[1:x] %in% paste('gene',ind,sep='')==T)]
  name2<-names(sort(data[,2],decreasing=T))
  t.name2<-name2[which(name2[1:x] %in% paste('gene',ind,sep='')==T)]
  name3<-names(sort(data[,3],decreasing=T))
  t.name3<-name3[which(name3[1:x] %in% paste('gene',ind,sep='')==T)]
  name4<-names(sort(data[,4],decreasing=T))
  t.name4<-name4[which(name4[1:x] %in% paste('gene',ind,sep='')==T)]
  name5<-names(sort(data[,5],decreasing=T))
  t.name5<-name5[which(name5[1:x] %in% paste('gene',ind,sep='')==T)]
  true<-union(union(union(union(t.name1,t.name2),t.name3),t.name4),t.name5)
  if(length(true)>=x) {return(x)}
  else return(length(true))
}

tp.number.hsb.fisher.K5.homo <-function(x, p, ind){
  name<-names(sort(p,decreasing=F))
  t.name<-name[which(name[1:x] %in% paste('gene',ind,sep='')==T)]
  return(length(t.name))
}


tp.number.hsb.meta.bayes.K2.hetero.low<-function(x,data,ind){
  ind1<-ind[[1]]
  ind2<-ind[[2]]
  name1<-names(sort(data[,1],decreasing=T))
  t.name1<-name1[which(name1[1:x] %in% paste('gene',ind1,sep='')==T)]
  name2<-names(sort(data[,2],decreasing=T))
  t.name2<-name2[which(name2[1:x] %in% paste('gene',ind2,sep='')==T)]
  #  if(length(t.name1)>length(t.name2)) true<-t.name1 else{true<-t.name2}
  true<-union(t.name1,t.name2)
  if(length(true)>=x) {return(x)}
  else return(length(true))
}

tp.number.hsb.fisher.K2.hetero.low<-function(x, p, ind){
  name<-names(sort(p,decreasing=F))
  t.name<-name[which(name[1:x] %in% paste('gene',ind,sep='')==T)]
  return(length(t.name))
}

tp.number.hsb.meta.bayes.K2.hetero.high<-function(x,data,ind){
  ind1<-ind[[1]]
  ind2<-ind[[2]]
  name1<-names(sort(data[,1],decreasing=T))
  t.name1<-name1[which(name1[1:x] %in% paste('gene',ind1,sep='')==T)]
  name2<-names(sort(data[,2],decreasing=T))
  t.name2<-name2[which(name2[1:x] %in% paste('gene',ind2,sep='')==T)]
  #  if(length(t.name1)>length(t.name2)) true<-t.name1 else{true<-t.name2}
  true<-union(t.name1,t.name2)
  if(length(true)>=x) {return(x)}
  else return(length(true))
}

tp.number.hsb.fisher.K2.hetero.high<-function(x, p, ind){
  name<-names(sort(p,decreasing=F))
  t.name<-name[which(name[1:x] %in% paste('gene',ind,sep='')==T)]
  return(length(t.name))
}

tp.number.hsb.meta.bayes.K5.hetero.low <-function(x,data,ind){
  ind2<-ind[[1]]
  ind3<-ind[[2]]
  ind4<-ind[[3]]
  ind5<-ind[[4]]
  name2<-names(sort(data[,2],decreasing=T))
  t.name2<-name2[which(name2[1:x] %in% paste('gene',ind2,sep='')==T)]
  name3<-names(sort(data[,3],decreasing=T))
  t.name3<-name3[which(name3[1:x] %in% paste('gene',ind3,sep='')==T)]
  name4<-names(sort(data[,4],decreasing=T))
  t.name4<-name4[which(name4[1:x] %in% paste('gene',ind4,sep='')==T)]
  name5<-names(sort(data[,5],decreasing=T))
  t.name5<-name5[which(name5[1:x] %in% paste('gene',ind5,sep='')==T)]
  true<-union(union(union(t.name2,t.name3),t.name4),t.name5)
  if(length(true)>=x) {return(x)}
  else return(length(true))
}

tp.number.hsb.fisher.K5.hetero.low <-function(x, p, ind){
  name<-names(sort(p,decreasing=F))
  t.name<-name[which(name[1:x] %in% paste('gene',ind,sep='')==T)]
  return(length(t.name))
}

tp.number.hsb.meta.bayes.K5.hetero.high <-function(x,data,ind){
  name1<-names(sort(data[,1],decreasing=T))
  t.name1<-name1[which(name1[1:x] %in% paste('gene',ind,sep='')==T)]
  name2<-names(sort(data[,2],decreasing=T))
  t.name2<-name2[which(name2[1:x] %in% paste('gene',ind,sep='')==T)]
  name3<-names(sort(data[,3],decreasing=T))
  t.name3<-name3[which(name3[1:x] %in% paste('gene',ind,sep='')==T)]
  name4<-names(sort(data[,4],decreasing=T))
  t.name4<-name4[which(name4[1:x] %in% paste('gene',ind,sep='')==T)]
  name5<-names(sort(data[,5],decreasing=T))
  t.name5<-name5[which(name5[1:x] %in% paste('gene',ind,sep='')==T)]
  true<-union(union(union(union(t.name1,t.name2),t.name3),t.name4),t.name5) 
  if(length(true)>=x) {return(x)}
  else return(length(true))
}

tp.number.hsb.fisher.K5.hetero.high <-function(x, p, ind){
  name<-names(sort(p,decreasing=F))
  t.name<-name[which(name[1:x] %in% paste('gene',ind,sep='')==T)]
  return(length(t.name))
}


sens.spec.meta.bayes.K2.homo <- function(x,data,ind,not.ind) {
  sort1<-sort(data[,1],decreasing=T)
  sort2<-sort(data[,2],decreasing=T)
  pos.name1<-names(sort1)[which(sort1>=(1-x))]
  pos.name2<-names(sort2)[which(sort2>=(1-x))]
  neg.name1<-names(sort1)[which(sort1<(1-x))]
  neg.name2<-names(sort2)[which(sort2<(1-x))]
  
  tp1<-pos.name1[which(pos.name1 %in% paste('gene',ind,sep='')==T)]
  tp2<-pos.name2[which(pos.name2 %in% paste('gene',ind,sep='')==T)]
  tp<-union(tp1,tp2)  
  sens<-ifelse(length(tp)>=length(ind),1,length(tp)/length(ind) )
  
  tn1<-neg.name1[which(neg.name1 %in% paste('gene',not.ind,sep='')==T)]
  tn2<-neg.name2[which(neg.name2 %in% paste('gene',not.ind,sep='')==T)]
  if(length(tn1)>=length(tn2)) tn<-tn1 else {tn<-tn2}  
  spec<-ifelse(length(tn)>=length(not.ind),1,length(tn)/length(not.ind) )
  return(c(sens,spec))
}

sens.fisher.K2.homo <-function(x,p,ind){
  name<-names(sort(p,decreasing=F))
  t.name<-name[which(name[1:x] %in% paste('gene',ind,sep='')==T)]
  return(length(t.name)/length(ind))
}

spec.fisher.K2.homo <-function(x, p, not.ind){
  name<-names(sort(p,decreasing=F))
  fp.name<-name[which(name[length(p):(x+1)] %in% paste('gene',not.ind,sep='')==T)]
  return(length(fp.name)/length(not.ind)) 
}

sens.spec.meta.bayes.K5.homo <- function(x,data,ind,not.ind) {
  sort1<-sort(data[,1],decreasing=T)
  sort2<-sort(data[,2],decreasing=T)
  sort3<-sort(data[,3],decreasing=T)
  sort4<-sort(data[,4],decreasing=T)
  sort5<-sort(data[,5],decreasing=T)
  
  pos.name1<-names(sort1)[which(sort1>=(1-x))]
  pos.name2<-names(sort2)[which(sort2>=(1-x))]
  pos.name3<-names(sort3)[which(sort3>=(1-x))]
  pos.name4<-names(sort4)[which(sort4>=(1-x))]
  pos.name5<-names(sort5)[which(sort5>=(1-x))]
  
  neg.name1<-names(sort1)[which(sort1<(1-x))]
  neg.name2<-names(sort2)[which(sort2<(1-x))]
  neg.name3<-names(sort3)[which(sort3<(1-x))]
  neg.name4<-names(sort4)[which(sort4<(1-x))]
  neg.name5<-names(sort5)[which(sort5<(1-x))]
  
  tp1<-pos.name1[which(pos.name1 %in% paste('gene',ind,sep='')==T)]
  tp2<-pos.name2[which(pos.name2 %in% paste('gene',ind,sep='')==T)]
  tp3<-pos.name3[which(pos.name3 %in% paste('gene',ind,sep='')==T)]
  tp4<-pos.name4[which(pos.name4 %in% paste('gene',ind,sep='')==T)]
  tp5<-pos.name5[which(pos.name5 %in% paste('gene',ind,sep='')==T)]
  tp<-union(union(union(union(tp1,tp2),tp3),tp4),tp5)  
  sens<-ifelse(length(tp)>=length(ind),1,length(tp)/length(ind) )
  
  tn1<-neg.name1[which(neg.name1 %in% paste('gene',not.ind,sep='')==T)]
  tn2<-neg.name2[which(neg.name2 %in% paste('gene',not.ind,sep='')==T)]
  tn3<-neg.name3[which(neg.name3 %in% paste('gene',not.ind,sep='')==T)]
  tn4<-neg.name4[which(neg.name4 %in% paste('gene',not.ind,sep='')==T)]
  tn5<-neg.name5[which(neg.name5 %in% paste('gene',not.ind,sep='')==T)]
  
  tn.list<-list(tn1,tn2,tn3,tn4,tn5)
  tn<-tn.list[[which.max(sapply(tn.list,length))]]
  
  spec<-ifelse(length(tn)>=length(not.ind),1,length(tn)/length(not.ind) )
  return(c(sens,spec))
}

sens.fisher.K5.homo <-function(x,p,ind){
  name<-names(sort(p,decreasing=F))
  t.name<-name[which(name[1:x] %in% paste('gene',ind,sep='')==T)]
  return(length(t.name)/length(ind))
}

spec.fisher.K5.homo <-function(x, p, not.ind){
  name<-names(sort(p,decreasing=F))
  fp.name<-name[which(name[length(p):(x+1)] %in% paste('gene',not.ind,sep='')==T)]
  return(length(fp.name)/length(not.ind)) 
}


sens.spec.meta.bayes.K2.hetero.low <- function(x,data,ind,not.ind) {
  ind1<-ind[[1]]
  ind2<-ind[[2]]
  sort1<-sort(data[,1],decreasing=T)
  sort2<-sort(data[,2],decreasing=T)
  pos.name1<-names(sort1)[which(sort1>=(1-x))]
  pos.name2<-names(sort2)[which(sort2>=(1-x))]
  neg.name1<-names(sort1)[which(sort1<(1-x))]
  neg.name2<-names(sort2)[which(sort2<(1-x))]
  
  tp1<-pos.name1[which(pos.name1 %in% paste('gene',ind1,sep='')==T)]
  tp2<-pos.name2[which(pos.name2 %in% paste('gene',ind2,sep='')==T)]
  tp<-union(tp1,tp2)  
  sens<-ifelse(length(tp)>=max(length(ind1),length(ind2)),
               1,length(tp)/max(length(ind1),length(ind2)) )
  
  tn1<-neg.name1[which(neg.name1 %in% paste('gene',not.ind,sep='')==T)]
  tn2<-neg.name2[which(neg.name2 %in% paste('gene',not.ind,sep='')==T)]
  if(length(tn1)>=length(tn2)) tn<-tn1 else {tn<-tn2}  
  spec<-ifelse(length(tn)>=length(not.ind),1,length(tn)/length(not.ind) )
  return(c(sens,spec))
}

sens.fisher.K2.hetero.low <-function(x,p,ind){
  name<-names(sort(p,decreasing=F))
  t.name<-name[which(name[1:x] %in% paste('gene',ind,sep='')==T)]
  return(length(t.name)/length(ind))
}

spec.fisher.K2.hetero.low <-function(x, p, not.ind){
  name<-names(sort(p,decreasing=F))
  fp.name<-name[which(name[length(p):(x+1)] %in% paste('gene',not.ind,sep='')==T)]
  return(length(fp.name)/length(not.ind)) 
}

sens.spec.meta.bayes.K2.hetero.high <- function(x,data,ind,not.ind) {
  ind1<-ind[[1]]
  ind2<-ind[[2]]
  sort1<-sort(data[,1],decreasing=T)
  sort2<-sort(data[,2],decreasing=T)
  pos.name1<-names(sort1)[which(sort1>=(1-x))]
  pos.name2<-names(sort2)[which(sort2>=(1-x))]
  neg.name1<-names(sort1)[which(sort1<(1-x))]
  neg.name2<-names(sort2)[which(sort2<(1-x))]
  
  tp1<-pos.name1[which(pos.name1 %in% paste('gene',ind1,sep='')==T)]
  tp2<-pos.name2[which(pos.name2 %in% paste('gene',ind2,sep='')==T)]
  tp<-union(tp1,tp2)  
  sens<-ifelse(length(tp)>=max(length(ind1),length(ind2)),
               1,length(tp)/max(length(ind1),length(ind2)) )
                 
  tn1<-neg.name1[which(neg.name1 %in% paste('gene',not.ind,sep='')==T)]
  tn2<-neg.name2[which(neg.name2 %in% paste('gene',not.ind,sep='')==T)]
  if(length(tn1)>=length(tn2)) tn<-tn1 else {tn<-tn2}  
  spec<-ifelse(length(tn)>=length(not.ind),1,length(tn)/length(not.ind) )
  return(c(sens,spec))
}

sens.fisher.K2.hetero.high <-function(x,p,ind){
  name<-names(sort(p,decreasing=F))
  t.name<-name[which(name[1:x] %in% paste('gene',ind,sep='')==T)]
  return(length(t.name)/length(ind))
}

spec.fisher.K2.hetero.high <-function(x, p, not.ind){
  name<-names(sort(p,decreasing=F))
  fp.name<-name[which(name[length(p):(x+1)] %in% paste('gene',not.ind,sep='')==T)]
  return(length(fp.name)/length(not.ind)) 
}


sens.spec.meta.bayes.K5.hetero.low <- function(x,data,ind,not.ind) {
  ind2<-ind[[1]]
  ind3<-ind[[2]]
  ind4<-ind[[3]]
  ind5<-ind[[4]]
  sort1<-sort(data[,1],decreasing=T)
  sort2<-sort(data[,2],decreasing=T)
  sort3<-sort(data[,3],decreasing=T)
  sort4<-sort(data[,4],decreasing=T)
  sort5<-sort(data[,5],decreasing=T)
  
  pos.name2<-names(sort2)[which(sort2>=(1-x))]
  pos.name3<-names(sort3)[which(sort3>=(1-x))]
  pos.name4<-names(sort4)[which(sort4>=(1-x))]
  pos.name5<-names(sort5)[which(sort5>=(1-x))]
  
  neg.name1<-names(sort1)[which(sort1<(1-x))]
  neg.name2<-names(sort2)[which(sort2<(1-x))]
  neg.name3<-names(sort3)[which(sort3<(1-x))]
  neg.name4<-names(sort4)[which(sort4<(1-x))]
  neg.name5<-names(sort5)[which(sort5<(1-x))]
  
  tp2<-pos.name2[which(pos.name2 %in% paste('gene',ind2,sep='')==T)]
  tp3<-pos.name3[which(pos.name3 %in% paste('gene',ind3,sep='')==T)]
  tp4<-pos.name4[which(pos.name4 %in% paste('gene',ind4,sep='')==T)]
  tp5<-pos.name5[which(pos.name5 %in% paste('gene',ind5,sep='')==T)]
  tp<-union(union(union(tp2,tp3),tp4),tp5)
  
  sens<-ifelse(length(tp)>=max(length(ind2),length(ind3),length(ind4),
                               length(ind5)),
               1,length(tp)/max(length(ind2),length(ind3),length(ind4),
                                length(ind5)) ) 
  
  tn1<-neg.name1[which(neg.name1 %in% paste('gene',not.ind,sep='')==T)]
  tn2<-neg.name2[which(neg.name2 %in% paste('gene',not.ind,sep='')==T)]
  tn3<-neg.name3[which(neg.name3 %in% paste('gene',not.ind,sep='')==T)]
  tn4<-neg.name4[which(neg.name4 %in% paste('gene',not.ind,sep='')==T)]
  tn5<-neg.name5[which(neg.name5 %in% paste('gene',not.ind,sep='')==T)]
  
  tn.list<-list(tn1,tn2,tn3,tn4,tn5)
  tn<-tn.list[[which.max(sapply(tn.list,length))]]
  
  spec<-ifelse(length(tn)>=length(not.ind),1,length(tn)/length(not.ind) )
  return(c(sens,spec))
}

sens.fisher.K5.hetero.low<-function(x,p,ind){
  name<-names(sort(p,decreasing=F))
  t.name<-name[which(name[1:x] %in% paste('gene',ind,sep='')==T)]
  return(length(t.name)/length(ind))
}

spec.fisher.K5.hetero.low<-function(x, p, not.ind){
  name<-names(sort(p,decreasing=F))
  fp.name<-name[which(name[length(p):(x+1)] %in% paste('gene',not.ind,sep='')==T)]
  return(length(fp.name)/length(not.ind)) 
}


sens.spec.meta.bayes.K5.hetero.high <- function(x,data,ind,not.ind) {
  sort1<-sort(data[,1],decreasing=T)
  sort2<-sort(data[,2],decreasing=T)
  sort3<-sort(data[,3],decreasing=T)
  sort4<-sort(data[,4],decreasing=T)
  sort5<-sort(data[,5],decreasing=T)
  
  pos.name1<-names(sort1)[which(sort1>=(1-x))]
  pos.name2<-names(sort2)[which(sort2>=(1-x))]
  pos.name3<-names(sort3)[which(sort3>=(1-x))]
  pos.name4<-names(sort4)[which(sort4>=(1-x))]
  pos.name5<-names(sort5)[which(sort5>=(1-x))]
  
  neg.name1<-names(sort1)[which(sort1<(1-x))]
  neg.name2<-names(sort2)[which(sort2<(1-x))]
  neg.name3<-names(sort3)[which(sort3<(1-x))]
  neg.name4<-names(sort4)[which(sort4<(1-x))]
  neg.name5<-names(sort5)[which(sort5<(1-x))]
  
  tp1<-pos.name1[which(pos.name1 %in% paste('gene',ind,sep='')==T)]
  tp2<-pos.name2[which(pos.name2 %in% paste('gene',ind,sep='')==T)]
  tp3<-pos.name3[which(pos.name3 %in% paste('gene',ind,sep='')==T)]
  tp4<-pos.name4[which(pos.name4 %in% paste('gene',ind,sep='')==T)]
  tp5<-pos.name5[which(pos.name5 %in% paste('gene',ind,sep='')==T)]
  tp<-union(union(union(union(tp1,tp2),tp3),tp4),tp5)  
  sens<-ifelse(length(tp)>=length(ind),1,length(tp)/length(ind) )
  
  tn1<-neg.name1[which(neg.name1 %in% paste('gene',not.ind,sep='')==T)]
  tn2<-neg.name2[which(neg.name2 %in% paste('gene',not.ind,sep='')==T)]
  tn3<-neg.name3[which(neg.name3 %in% paste('gene',not.ind,sep='')==T)]
  tn4<-neg.name4[which(neg.name4 %in% paste('gene',not.ind,sep='')==T)]
  tn5<-neg.name5[which(neg.name5 %in% paste('gene',not.ind,sep='')==T)]
  
  tn.list<-list(tn1,tn2,tn3,tn4,tn5)
  tn<-tn.list[[which.max(sapply(tn.list,length))]]
  
  spec<-ifelse(length(tn)>=length(not.ind),1,length(tn)/length(not.ind) )
  return(c(sens,spec))
}

sens.fisher.K5.hetero.high<-function(x,p,ind){
  name<-names(sort(p,decreasing=F))
  t.name<-name[which(name[1:x] %in% paste('gene',ind,sep='')==T)]
  return(length(t.name)/length(ind))
}

spec.fisher.K5.hetero.high<-function(x, p, not.ind){
  name<-names(sort(p,decreasing=F))
  fp.name<-name[which(name[length(p):(x+1)] %in% paste('gene',not.ind,sep='')==T)]
  return(length(fp.name)/length(not.ind)) 
}

